#!/bin/sh
# $Id: steamclient.SlackBuild,v 1.25 2021/12/28 11:38:42 root Exp root $
# Copyright 2012, 2013, 2014, 2015, 2016, 2020, 2021, 2023  Eric Hameleers, Eindhoven, NL
# All rights reserved.
#
#   Permission to use, copy, modify, and distribute this software for
#   any purpose with or without fee is hereby granted, provided that
#   the above copyright notice and this permission notice appear in all
#   copies.
#
#   THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
#   WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#   MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
#   IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
#   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
#   USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
#   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
#   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
#   OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#   SUCH DAMAGE.
# -----------------------------------------------------------------------------
#
# Slackware SlackBuild script 
# ===========================
# By:          Eric Hameleers <alien@slackware.com>
# For:         steamclient
# Descr:       Linux client for the Steam gaming platform
# URL:         http://valvesoftware.com/
# Needs:       
# Changelog:   
# 20121216-1:  16/Dec/2012 by Eric Hameleers <alien@slackware.com>
#              * Initial build.
# 1.0.0.22-1:  28/jan/2013 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 1.0.0.25-1:  11/feb/2013 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 1.0.0.27-1:  14/feb/2013 by Eric Hameleers <alien@slackware.com>
#              * Update. No longer in Beta!
# 1.0.0.28-1:  16/feb/2013 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 1.0.0.31-1:  23/feb/2013 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 1.0.0.33-1:  24/feb/2013 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 1.0.0.34-1:  25/feb/2013 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 1.0.0.35-1:  02/mar/2013 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 1.0.0.36-1:  02/mar/2013 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 1.0.0.38-1:  25/apr/2013 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 1.0.0.39-1:  10/may/2013 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 1.0.0.40-1:  01/sep/2013 by Eric Hameleers <alien@slackware.com>
#              * An update which is not really relevant to Slackware.
# 1.0.0.41-1:  09/sep/2013 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 1.0.0.42-1:  14/sep/2013 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 1.0.0.44-1:  16/nov/2013 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 1.0.0.45-1:  30/nov/2013 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 1.0.0.48-1:  21/jun/2014 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 1.0.0.49-1:  29/aug/2014 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 1.0.0.50-1:  08/may/2015 by Eric Hameleers <alien@slackware.com>
#              * Update. The libXinerama and libXext were added to the
#                bootstrap runtime to fix AMD graphics driver crashing
# 1.0.0.51-1:  19/nov/2015 by Eric Hameleers <alien@slackware.com>
#                - Add uinput rule for the Steam Controller.
#                - Remove udev rule for the Oculus Rift VR headset.
#                - Add udev rule for HTC Vive VR headset.
# 1.0.0.51-2:  19/dec/2015 by Eric Hameleers <alien@slackware.com>
#                - use LD_PRELOAD to favor the system ALSA library - this fixes
#                  a steam-runtime conflict. Thanks to Ryan McQuen.
# 1.0.0.54-1:  17/dec/2016 by Eric Hameleers <alien@slackware.com>
#                - Update.
# 1.0.0.66-1:  30/sep/2020 by Eric Hameleers <alien@slackware.com>
#                - Update.
# 1.0.0.74-1:  27/dec/2021 by Eric Hameleers <alien@slackware.com>
#                - Update.
# 1.0.0.76-1:  19/mar/2023 by Eric Hameleers <alien@slackware.com>
#                - Update.
#
# Run 'sh steamclient.SlackBuild' to build a Slackware package.
# The package (.txz) and .txt file as well as build logs are created in /tmp .
# Install it using 'installpkg'. 
#
# -----------------------------------------------------------------------------

PRGNAM=steamclient
VERSION=${VERSION:-1.0.0.76} # Use "LATEST" to just dowload the latest version.
BUILD=${BUILD:-1}
TAG=${TAG:-alien}

if [ -z "$ARCH" ]; then
  case "$(uname -m)" in
    i?86) ARCH=i386 ;;
    x86_64) ARCH=x86_64 ;;
    *) echo "Unsupported architecture'!"; exit 1 ;;
  esac
  export ARCH
fi

# Where do we look for sources?
SRCDIR=$(cd $(dirname $0); pwd)

# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
TMP=${TMP:-/tmp/build}
PKG=$TMP/package-$PRGNAM
OUTPUT=${OUTPUT:-/tmp}

if [ "$VERSION" = "LATEST" ]; then
  # We'll re-define VERSION later.
  SRCURL="http://repo.steampowered.com/steam/archive/precise/steam_latest.tar.gz"
  SOURCE="$SRCDIR/steam_latest.tar.gz"
else
  SRCURL="http://repo.steampowered.com/steam/pool/steam/s/steam/steam_${VERSION}.tar.gz"
  SOURCE="$SRCDIR/steam_${VERSION}.tar.gz"
fi

##
## --- with a little luck, you won't have to edit below this point --- ##
##

# Exit the script on errors:
set -e
trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
# Catch unitialized variables:
set -u
P1=${1:-1}

# Save old umask and set to 0022:
_UMASK_=$(umask)
umask 0022

# Create working directories:
mkdir -p $OUTPUT          # place for the package to be saved
mkdir -p $TMP/tmp-$PRGNAM # location to build the source
mkdir -p $PKG             # place for the package to be built
rm -rf $PKG/*             # always erase old package's contents
rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
rm -rf $OUTPUT/{configure,make,install,error,makepkg}-$PRGNAM.log
                          # remove old log files

# Source file availability:
if ! [ -f ${SOURCE} ]; then
  echo "Source '$(basename ${SOURCE})' not available yet..."
  # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
  [ -w "$SRCDIR" ] || SOURCE="$OUTPUT/$(basename $SOURCE)"
  if [ -f ${SOURCE} ]; then echo "Ah, found it!"; continue; fi
  if ! [ "x${SRCURL}" == "x" ]; then
    echo "Will download file to $(dirname $SOURCE)"
    wget -nv -T 20 -O "${SOURCE}" "${SRCURL}" || true
    if [ $? -ne 0 -o ! -s "${SOURCE}" ]; then
      echo "Downloading '$(basename ${SOURCE})' failed... aborting the build."
      mv -f "${SOURCE}" "${SOURCE}".FAIL
      exit 1
    fi
  else
    echo "File '$(basename ${SOURCE})' not available... aborting the build."
    exit 1
  fi
fi

if [ "$P1" == "--download" ]; then
  echo "Download complete."
  exit 0
fi

# --- PACKAGE BUILDING ---

echo "++"
echo "|| $PRGNAM-$VERSION"
echo "++"

cd $TMP/tmp-$PRGNAM

echo "Extracting the source archive(s) for $PRGNAM..."
tar xf ${SOURCE}

# Version check in case we downloaded the "latest" client:
if [ "$VERSION" = "LATEST" ]; then
  echo -n "Changing package version from '$VERSION' to"
  VERSION=$(head -1 steam*/debian/changelog | cut -d'(' -f2 | cut -d')' -f1 |cut -d: -f2)
  echo " '$VERSION'."
fi

mv steam-launcher steam-${VERSION} 2>/dev/null || true
cd steam-${VERSION}
chown -R root:root .
chmod -R u+w,go+r-w,a+X-s .

# Move the binaries into place (mostly copied from the Makefile:
install -d -m0755 $PKG/usr/bin/
install -d -m0755 $PKG/usr/lib/steam/steam_launcher/
install -p -m0755 bin_steam.sh $PKG/usr/lib/steam/
install -p -m0644 steam_launcher/__init__.py $PKG/usr/lib/steam/steam_launcher/
install -p -m0644 steam_launcher/launcherutils.py $PKG/usr/lib/steam/steam_launcher/
ln -sf /usr/lib/steam/bin_steam.sh $PKG/usr/bin/steam
# We don't use apt or dpkg or whatever:
cat << EOT > $PKG/usr/bin/steamdeps
#!/bin/sh
echo "# ------------------------------------ #"
echo -e "\nSlackware 32-bit:\nCheck the directory matching your Slackware version below http://www.slackware.com/~alien/slackbuilds/steamclient/deps/ . Install/upgrade any packages you find there (may be zero)."
echo -e "\nSlackware 64-bit:\nYou need to install multilib (see https://docs.slackware.com/slackware:multilib). Additionally, you need to install/upgrade any packages in the '<slackwareversion>/multilib' subdirectory of http://www.slackware.com/~alien/slackbuilds/steamclient/deps/ instead.\n"
echo "# ------------------------------------ #"
exit 0
EOT
chmod 755 $PKG/usr/bin/steamdeps
ln -sf /usr/bin/steamdeps $PKG/usr/lib/steam/bin_steamdeps.py

# Install the desktop menu:
install -d -m0755 $PKG/usr/share/applications
install -p -m0644 steam.desktop $PKG/usr/share/applications/
# The client install expects this to be present:
ln -s /usr/share/applications/steam.desktop $PKG/usr/lib/steam/
# Install icons:
for size in 16 24 32 48 256 ; do
  install -d -m0755 $PKG/usr/share/icons/hicolor/${size}x${size}/apps/
  install -p -m0644 icons/${size}/steam.png \
    $PKG/usr/share/icons/hicolor/${size}x${size}/apps/
done
install -d -m0755 $PKG/usr/share/pixmaps/
install -p -m0644 icons/48/steam.png $PKG/usr/share/pixmaps/
install -p -m0644 icons/48/steam.png $PKG/usr/share/pixmaps/steam_tray.png
install -p -m0644 icons/48/steam_tray_mono.png $PKG/usr/share/pixmaps/steam_tray_mono.png

# Install the steam bootstrap:
install -d -m0755 $PKG/usr/lib/steam/
install -p -m0644 bootstraplinux_*_32.tar.xz $PKG/usr/lib/steam/

# Install udev rule for the Steam Controller and VR headset:
install -D -m0644 subprojects/steam-devices/60-steam-input.rules \
  $PKG/usr/lib/udev/rules.d/60-steam-input.rules
install -D -m0644 subprojects/steam-devices/60-steam-vr.rules \
  $PKG/usr/lib/udev/rules.d/60-steam-vr.rules

# Add some documentation:
install -D -t $PKG/usr/share/metainfo/ -m0644 com.valvesoftware.Steam.metainfo.xml
mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
cp -ia COPYING README steam_subscriber_agreement.txt \
  $PKG/usr/doc/$PRGNAM-$VERSION || true
cp -a $SRCDIR/README.Slackware $PKG/usr/doc/$PRGNAM-$VERSION || true
cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
find $PKG/usr/doc -type f -exec chmod 644 {} \;

# Take care of the man page:
install -d -m0755 $PKG/usr/man/man6/
install -p -m0644 steam.6 $PKG/usr/man/man6/
gzip $PKG/usr/man/man6/steam.6

cd ${PKG}
# Apply changes to the steam script which we need on Slackware:
sed -i -e '/env bash/ a\
# --- Start Slackware mod ---\
# If PulseAudio is disabled, audio output goes to first "hw" device of ALSA.\
# Try uncommenting below lines if you dont use PulseAudio and have no sound:\
#export LD_PRELOAD='"'"'/usr/$LIB/libasound.so.2'"'"'\
#export SDL_AUDIODRIVER=alsa\
#export AUDIODEV=hw\
# On window close, minimize to the system tray area:\
export STEAM_FRAME_FORCE_CLOSE=1\
# Add any custom variable exports here\
[ -f ${HOME}/.steam4slackware ] \&\& . ${HOME}/.steam4slackware\
# --- End Slackware mod ---' $PKG/usr/lib/steam/bin_steam.sh
# We need to add symlinks to /sbin/pidof and /sbin/lcpci
# in order to make them be found:
sed -i -e '/Start Slackware mod/{s#$#\nexport PATH="/usr/lib/steam/local:$PATH"#}' $PKG/usr/lib/steam/bin_steam.sh
# Use the system terminal instead of plain xterm:
sed -i -e 's/xterm/${TERM}/' $PKG/usr/lib/steam/bin_steam.sh

# Our 'pidof' and 'lspci' workaround:
mkdir $PKG/usr/lib/steam/local
ln -sf /sbin/lspci $PKG/usr/lib/steam/local/lspci
ln -sf /sbin/pidof $PKG/usr/lib/steam/local/pidof

# Add this to the doinst.sh:
mkdir -p $PKG/install
cat <<EOINS >> $PKG/install/doinst.sh
# Handle the incoming configuration files:
config() {
  for infile in \$1; do
    NEW="\$infile"
    OLD="\`dirname \$NEW\`/\`basename \$NEW .new\`"
    # If there's no config file by that name, mv it over:
    if [ ! -r \$OLD ]; then
      mv \$NEW \$OLD
    elif [ "\`cat \$OLD | md5sum\`" = "\`cat \$NEW | md5sum\`" ]; then
      # toss the redundant copy
      rm \$NEW
    fi
    # Otherwise, we leave the .new copy for the admin to consider...
  done
}

# An example of how you handle your '.new' config files:
#config etc/steamclient.conf.new

# Update the desktop database:
if [ -x usr/bin/update-desktop-database ]; then
  chroot . /usr/bin/update-desktop-database usr/share/applications > /dev/null 2>&1
fi

# Update hicolor theme cache:
if [ -d usr/share/icons/hicolor ]; then
  if [ -x /usr/bin/gtk-update-icon-cache ]; then
    chroot . /usr/bin/gtk-update-icon-cache -f -t usr/share/icons/hicolor 1> /dev/null 2> /dev/null
  fi
fi

# Update the mime database:
if [ -x usr/bin/update-mime-database ]; then
  chroot . /usr/bin/update-mime-database usr/share/mime >/dev/null 2>&1
fi
EOINS

# Add a package description:
mkdir -p $PKG/install
cat $SRCDIR/slack-desc > $PKG/install/slack-desc
if [ -f $SRCDIR/doinst.sh ]; then
  cat $SRCDIR/doinst.sh >> $PKG/install/doinst.sh
fi
if [ -f $SRCDIR/slack-required ]; then
  cat $SRCDIR/slack-required > $PKG/install/slack-required
fi

# Build the package:
cd $PKG
makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz} 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
cd $OUTPUT
md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz} > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz}.md5
cd -
cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt
if [ -f $PKG/install/slack-required ]; then
  cat $PKG/install/slack-required > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.dep
fi

# Restore the original umask:
umask ${_UMASK_}

